#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <math.h>

typedef unsigned long DWORD;
typedef unsigned short WORD;
typedef unsigned char BYTE;
typedef unsigned long long DDWORD;

#define DEBUG
#define MAX_DIM 100000
#define MAX_VCNT 100000
#define NUM 0
#define DEN	1

int w, h, nt, nb, yt, yb;
typedef struct _pointA_
{
	int x;
	int y;
} PNTA, *PPNTA;
PNTA toppts[MAX_VCNT], botpts[MAX_VCNT];

int topy[MAX_DIM + 1], boty[MAX_DIM + 1];

int scanPolygons()
{
	PPNTA pcurpt, pnxtpt;
	int i, j, dx, dy, x, cur, y;
	int adx, ady, astep, arem, xstep, ystep, yextra;
	for(i = 0; i <= w ; i++) {
		topy[i] = h; boty[i] = -h;
	}
	pcurpt = &(toppts[0]); pnxtpt = &(toppts[1]);
	topy[0] = pcurpt->y;
	for(i = 0; i < (nt -1) ; i++) {
		cur = 0;
		x = pcurpt->x;
		y = pcurpt->y;
		dx = pnxtpt->x - pcurpt->x;
		dy = pnxtpt->y - pcurpt->y;
		adx = dx; ady = dy;xstep = 1;
		if(dx == 0) {
			if(dy >= 0) {
				topy[x] = y;
			} else {
				topy[x] = y + dy;
			}
		} else {
			if(dy < 0) {
				ady = -dy;
			}
			if(dx < 0) {
				adx = -dx;
				xstep = -1;
			}
			ystep = astep = ady/adx; yextra = 1; arem = ady % adx;
			if(dy < 0) {
				ystep = -astep; yextra = -1;
			}
			if(y < topy[x]) {
				topy[x] = y;
			}
			for(j = 0; j < adx; j++) {
				x += xstep;
				y += ystep;
				cur += arem;
				if(cur >= adx) {
					cur -= adx;
					y += yextra;
				}
				if(y < topy[x]) {
					topy[x] = y;
				}
			}
		}
		pcurpt = pnxtpt; pnxtpt++;
	}
	pcurpt = &(botpts[0]); pnxtpt = &(botpts[1]);
	boty[0] = pcurpt->y;
	for(i = 0; i < (nb -1) ; i++) {
		cur = 0;
		x = pcurpt->x;
		y = pcurpt->y;
		dx = pnxtpt->x - pcurpt->x;
		dy = pnxtpt->y - pcurpt->y;
		adx = dx; ady = dy;xstep = 1;
		if(dx == 0) {
			if(dy <= 0) {
				boty[x] = y;
			} else {
				boty[x] = y + dy;
			}
		} else {
			if(dy < 0) {
				ady = -dy;
			}
			if(dx < 0) {
				adx = -dx;
				xstep = -1;
			}
			ystep = astep = ady/adx; yextra = 1; arem = ady % adx;
			if(dy < 0) {
				ystep = -astep; yextra = -1;
			}
			if(y > boty[x]) {
				boty[x] = y;
			}
			for(j = 0; j < adx; j++) {
				x += xstep;
				y += ystep;
				cur += arem;
				if(cur >= adx) {
					cur -= adx;
					y += yextra;
				}
				if(y > boty[x]) {
					boty[x] = y;
				}
				if(boty[x] > topy[x]) {
					return -1;
				}
			}
		}
		pcurpt = pnxtpt; pnxtpt++;
	}
	return 0;
}

int FollowPathSpread()
{
	int x,  t;
	x = yt = yb = 0;
	if((topy[0] <= 0) || (boty[0] >= 0)) {
		return 0;
	}
	while(x < w) {
		yt++, yb--; x++;
		if((t = topy[x]) <= yt) {
			if((x ^ t) & 1) {
				yt = t - 1;
			} else {
				yt = t - 2;
			}
		}
		if((t = boty[x]) >= yb) {
			if((x ^ t) & 1) {
				yb = t + 1;
			} else {
				yb = t + 2;
			}
		}
//		printf("x %d ytb %d %d\n", x, yt, yb);
		if(yb > yt) {
			return 0;
		}
	}
	return ((yt - yb)/2 + 1);
}

void DumpTB()
{
	int i;
	for(i = 0; i <= w; i++) {
		printf("%d: %d %d\n", i, topy[i], boty[i]);
	}
}
char inbuf[2048];
int main()
{
	int i, x, y, ret;
	PPNTA ppt;
	if(fgets(&(inbuf[0]), 2048, stdin) == NULL) {
		fprintf(stderr, "read failed on counts\n");
		return -1;
	}
	if(sscanf(&(inbuf[0]), "%d %d %d %d", &nt, &nb, &w, &h) != 4) {
		fprintf(stderr, "scan failed on counts\n");
		return -2;
	}
	if((w < 1) || (w > MAX_DIM) || (h < 1) || (h > MAX_DIM)) {
		fprintf(stderr, "w %d and/or h %d not in range 1...%d\n", 
			w, h, MAX_DIM);
		return -3;
	}
	if((nt < 1) || (nt > MAX_VCNT) || (nb < 1) || (nb > MAX_VCNT)) {
		fprintf(stderr, "ntop %d and/or nbot %d not in range 1...%d\n", 
			nt, h, MAX_VCNT);
		return -4;
	}
//	printf("c %d %d %d %d\n", w, h, nt, nb);
	for(i = 0, ppt = &(toppts[0]) ; i < nt ; i++, ppt++) {
		if(fgets(&(inbuf[0]), 2048, stdin) == NULL) {
			fprintf(stderr, "read failed on top pt %d\n", i+1);
			return -5;
		}
		if(sscanf(&(inbuf[0]), "%d %d", &x, &y) != 2) {
			fprintf(stderr, "scan failed on top pt %d\n", i+1);
			return -6;
		}
		if((x < 0) || (x > w) || (y < -h) || (y > h)) {
			fprintf(stderr, "x %d not in range 0..%d and/or y %d not in range %d...%d on top pt %d\n",
				x, w, y, -h, h, i+1);
			return -7;
		}
//		printf("t %d %d\n", x, y);
		ppt->x = x; ppt->y = y;
	}
	for(i = 0, ppt = &(botpts[0]) ; i < nb ; i++, ppt++) {
		if(fgets(&(inbuf[0]), 2048, stdin) == NULL) {
			fprintf(stderr, "read failed on bot pt %d\n", i+1);
			return -8;
		}
		if(sscanf(&(inbuf[0]), "%d %d", &x, &y) != 2) {
			fprintf(stderr, "scan failed on bot pt %d\n", i+1);
			return -9;
		}
		if((x < 0) || (x > w) || (y < -h) || (y > h)) {
			fprintf(stderr, "x %d not in range 0..%d and/or y %d not in range %d...%d on bot pt %d\n", 
				x, w, y, -h, h, i+1);
			return -10;
		}
//		printf("t %d %d\n", x, y);
		ppt->x = x; ppt->y = y;
	}
	if(scanPolygons() != 0) {
		printf("0\n");
	} else {
//		DumpTB();
		if((ret = FollowPathSpread()) == 0) {
			printf("impossible\n");
		} else if  (ret > 0) {
			printf("%d %d\n", yb, yt);
		} else {
			return ret;
		}

	}
	return 0;
}

