#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <math.h>

typedef unsigned long DWORD;
typedef unsigned short WORD;
typedef unsigned char BYTE;

#undef DEBUG
#define MAX_DIM 100000
#define MAX_VCNT 100000
#define NUM 0
#define DEN	1

int w, h, nt, nb, yt, yb;
typedef struct _pointA_
{
	int x;
	int y;
} PNTA, *PPNTA;
PNTA toppts[MAX_VCNT], botpts[MAX_VCNT];

int topy[MAX_DIM + 1], boty[MAX_DIM + 1];

int scanPolygons()
{
	PPNTA pcurpt, pnxtpt;
	int i, j, dx, dy, x, cur, y;
	int ady, astep, arem, xstep, ystep, yextra;
	pcurpt = &(toppts[0]); pnxtpt = &(toppts[1]);
	topy[0] = pcurpt->y;
	for(i = 0; i < (nt -1) ; i++) {
		cur = 0;
		x = pcurpt->x;
		y = pcurpt->y;
		dx = pnxtpt->x - pcurpt->x;
		dy = pnxtpt->y - pcurpt->y;
		ady = dy;xstep = 1;
		if(dx == 0) {
			if(dy >= 0) {
				topy[x] = y;
			} else {
				topy[x] = y + dy;
			}
		} else if (dx == 1) {
			x++;
			topy[x] = pnxtpt->y;
		} else {
			if(dy < 0) {
				ady = -dy;
			}
			ystep = astep = ady/dx; yextra = 1; arem = ady % dx;
			if(dy < 0) {
				ystep = -astep; yextra = -1;
			}
			topy[x] = y;
			for(j = 0; j < dx; j++) {
				x += xstep;
				y += ystep;
				cur += arem;
				if(cur >= dx) {
					cur -= dx;
					y += yextra;
				}
				topy[x] = y;
			}
		}
		pcurpt = pnxtpt; pnxtpt++;
	}
	pcurpt = &(botpts[0]); pnxtpt = &(botpts[1]);
	boty[0] = pcurpt->y;
	for(i = 0; i < (nb -1) ; i++) {
		cur = 0;
		x = pcurpt->x;
		y = pcurpt->y;
		dx = pnxtpt->x - pcurpt->x;
		dy = pnxtpt->y - pcurpt->y;
		ady = dy;xstep = 1;
		if(dx == 0) {
			if(dy <= 0) {
				boty[x] = y;
			} else {
				boty[x] = y + dy;
			}
		} else if (dx == 1) {
			x++;
			boty[x] = pnxtpt->y;
		} else {
			if(dy < 0) {
				ady = -dy;
			}
			ystep = astep = ady/dx; yextra = 1; arem = ady % dx;
			if(dy < 0) {
				ystep = -astep; yextra = -1;
			}
			boty[x] = y;
			for(j = 0; j < dx; j++) {
				x += xstep;
				y += ystep;
				cur += arem;
				if(cur >= dx) {
					cur -= dx;
					y += yextra;
				}
				boty[x] = y;
				if(boty[x] >= topy[x]) {
					return -1;
				}
			}
		}
		pcurpt = pnxtpt; pnxtpt++;
	}
	return 0;
}

int FollowPathSpread()
{
	int x, t;
	x = yt = yb = 0;
	if((topy[0] <= 0) || (boty[0] >= 0)) {
		return 0;
	}
	while(x < w) {
		yt++, yb--; x++;
		if((t = topy[x]) <= yt) {
			if((x ^ t) & 1) {
				yt = t - 1;
			} else {
				yt = t - 2;
			}
		}
		if((t = boty[x]) >= yb) {
			if((x ^ t) & 1) {
				yb = t + 1;
			} else {
				yb = t + 2;
			}
		}
#ifdef DEBUG
		printf("x %d ytb %d %d\n", x, yt, yb);
#endif
		if(yb > yt) {
			return 0;
		}
	}
	return ((yt - yb)/2 + 1);
}

void DumpTB()
{
	int i;
	for(i = 0; i <= w; i++) {
		printf("%d: %d %d\n", i, topy[i], boty[i]);
	}
}
char inbuf[2048];
int main()
{
	int i, x, y, ret, xprev;
	PPNTA ppt;
	if(fgets(&(inbuf[0]), 2048, stdin) == NULL) {
		fprintf(stderr, "read failed on counts\n");
		return -1;
	}
	if(sscanf(&(inbuf[0]), "%d %d %d %d", &nt, &nb, &w, &h) != 4) {
		fprintf(stderr, "scan failed on counts\n");
		return -2;
	}
	if((w < 1) || (w > MAX_DIM) || (h < 1) || (h > MAX_DIM)) {
		fprintf(stderr, "w %d and/or h %d not in range 1...%d\n", 
			w, h, MAX_DIM);
		return -3;
	}
	if((nt < 1) || (nt > MAX_VCNT) || (nb < 1) || (nb > MAX_VCNT)) {
		fprintf(stderr, "ntop %d and/or nbot %d not in range 1...%d\n", 
			nt, h, MAX_VCNT);
		return -4;
	}
//	printf("c %d %d %d %d\n", w, h, nt, nb);
	if(fgets(&(inbuf[0]), 2048, stdin) == NULL) {
		fprintf(stderr, "read failed on firsttop pt \n");
		return -5;
	}
	if(sscanf(&(inbuf[0]), "%d %d", &x, &y) != 2) {
		fprintf(stderr, "scan failed on firsttop pt \n");
		return -6;
	}
	if((x != 0) || (y != h)) {
		fprintf(stderr, "first top pt (x %d , y %d) ! = (0, h %d)\n",
			x, y, h);
		return -7;
	}
	toppts[0].x = x; toppts[0].y = y;
	xprev = x;
	for(i = 1, ppt = &(toppts[1]) ; i < (nt-1) ; i++, ppt++) {
		if(fgets(&(inbuf[0]), 2048, stdin) == NULL) {
			fprintf(stderr, "read failed on top pt %d\n", i+1);
			return -5;
		}
		if(sscanf(&(inbuf[0]), "%d %d", &x, &y) != 2) {
			fprintf(stderr, "scan failed on top pt %d\n", i+1);
			return -6;
		}
		if((x < 0) || (x > w) || (y <= -h) || (y >= h)) {
			fprintf(stderr, "x %d not in range 0..%d and/or y %d not in range %d...%d on top pt %d\n",
				x, w, y, -(h-1), (h-1), i+1);
			return -7;
		}
		if(x < xprev) {
			fprintf(stderr, "x %d < prevx %d on	top pt %d\n",
				x, xprev, i+1);
			return -8;
		}
		xprev = x;
//		printf("t %d %d\n", x, y);
		ppt->x = x; ppt->y = y;
	}
	if(fgets(&(inbuf[0]), 2048, stdin) == NULL) {
		fprintf(stderr, "read failed on last top pt \n");
		return -5;
	}
	if(sscanf(&(inbuf[0]), "%d %d", &x, &y) != 2) {
		fprintf(stderr, "scan failed on last top pt \n");
		return -6;
	}
	if((x != w) || (y != h)) {
		fprintf(stderr, "last top pt (x %d , y %d) ! = (W %d, h %d)\n",
			x, y, w, h);
		return -7;
	}
	if(x < xprev) {
		fprintf(stderr, "last top x %d < prevx %d on\n",
			x, xprev);
		return -8;
	}
	toppts[nt - 1].x = x; toppts[nt-1].y = y;

	if(fgets(&(inbuf[0]), 2048, stdin) == NULL) {
		fprintf(stderr, "read failed on first bot pt \n");
		return -9;
	}
	if(sscanf(&(inbuf[0]), "%d %d", &x, &y) != 2) {
		fprintf(stderr, "scan failed on first bot pt \n");
		return -10;
	}
	if((x != 0) || (y != -h)) {
		fprintf(stderr, "first bot pt (x %d , y %d) ! = (0, h %d)\n",
			x, y, -h);
		return -11;
	}
	botpts[0].x = x; botpts[0].y = y;
	xprev = x;
	for(i = 1, ppt = &(botpts[1]) ; i < (nb-1) ; i++, ppt++) {
		if(fgets(&(inbuf[0]), 2048, stdin) == NULL) {
			fprintf(stderr, "read failed on bot pt %d\n", i+1);
			return -9;
		}
		if(sscanf(&(inbuf[0]), "%d %d", &x, &y) != 2) {
			fprintf(stderr, "scan failed on bot pt %d\n", i+1);
			return -10;
		}
		if((x < 0) || (x > w) || (y <= -h) || (y >= h)) {
			fprintf(stderr, "x %d not in range 0..%d and/or y %d not in range %d...%d on bot pt %d\n", 
				x, w, y, -(h-1), (h-1), i+1);
			return -11;
		}
		if(x < xprev) {
			fprintf(stderr, "x %d < prevx %d on	bot pt %d\n",
				x, xprev, i+1);
			return -12;
		}
		xprev = x;
//		printf("t %d %d\n", x, y);
		ppt->x = x; ppt->y = y;
	}
	if(fgets(&(inbuf[0]), 2048, stdin) == NULL) {
		fprintf(stderr, "read failed on last bot pt \n");
		return -9;
	}
	if(sscanf(&(inbuf[0]), "%d %d", &x, &y) != 2) {
		fprintf(stderr, "scan failed on last bot pt \n");
		return -10;
	}
	if((x != w) || (y != -h)) {
		fprintf(stderr, "last bot pt (x %d , y %d) ! = (W %d, h %d)\n",
			x, y, w, -h);
		return -11;
	}
	if(x < xprev) {
		fprintf(stderr, "last bot x %d < prevx %d on\n",
			x, xprev);
		return -12;
	}
	botpts[nb - 1].x = x; botpts[nb-1].y = y;

	if(scanPolygons() != 0) {
		printf("0\n");
	} else {
#ifdef DEBUG
		DumpTB();
#endif
		if((ret = FollowPathSpread()) == 0) {
			printf("impossible\n");
		} else if  (ret > 0) {
			printf("%d %d\n", yb, yt);
		} else {
			return ret;
		}
	}
	return 0;
}

