#include <algorithm>
#include <array>
#include <cstdint>
#include <iomanip>
#include <iostream>
#include <utility>
#include <vector>

using P = std::array<int64_t, 2>;

std::vector<int64_t> compute(int64_t w, int64_t h, const std::vector<P>& ceiling) {
    std::vector<int64_t> ans(w + 1, h);
    for (uint64_t i = 0; i + 1 < ceiling.size(); ++i) {
        auto [x0, y0] = ceiling[i];
        auto [x1, y1] = ceiling[i + 1];
        int64_t dx = x1 - x0;
        int64_t dy = y1 - y0;
        if (dx == 0) {
            ans[x0] = std::min({ans[x0], y0 - 1, y1 - 1});
        } else {
            for (int64_t x = x0; x <= x1; ++x) {
                int64_t num = (x - x0) * dy;
                ans[x] = std::min(ans[x], y0 + num / dx - (num % dx == 0));
            }
        }
    }

    return ans;
}

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    int64_t n, m, w, h;
    std::cin >> n >> m >> w >> h;
    std::vector<P> ceiling, floor;
    for (int64_t i = 0; i < n; ++i) {
        int64_t x, y;
        std::cin >> x >> y;
        ceiling.push_back(P{x, y});
    }
    for (int64_t i = 0; i < m; ++i) {
        int64_t x, y;
        std::cin >> x >> y;
        floor.push_back(P{x, -y});
    }

    auto top = compute(w, h, ceiling);
    auto bot = compute(w, h, floor);
    for (auto& x : bot)
        x = -x;

    int64_t lo = 0;
    int64_t hi = 0;
    for (int64_t i = 1; i <= w; ++i) {
        lo = std::max(lo - 1, bot[i] + ((bot[i] & 1) != (i & 1)));
        hi = std::min(hi + 1, top[i] - ((top[i] & 1) != (i & 1)));
        if (lo > hi) {
            std::cout << "impossible\n";
            return 0;
        }
    }

    std::cout << lo << ' ' << hi << '\n';

    return 0;
}
