def compute(w, h, ceiling):
    ans = [h for _ in range(w + 1)]
    for p0, p1 in zip(ceiling, ceiling[1:]):
        dx = p1[0] - p0[0]
        dy = p1[1] - p0[1]
        if dx == 0:
            ans[p0[0]] = min(ans[p0[0]], p0[1] - 1, p1[1] - 1)
        else:
            for x in range(p0[0], p1[0] + 1):
                num = (x - p0[0]) * dy
                ans[x] = min(ans[x], p0[1] + num // dx - int(num % dx == 0))

    return ans


def main():
    n, m, w, h = map(int, input().split())
    ceiling = []
    for _ in range(n):
        x, y = map(int, input().split())
        ceiling.append((x, y))
    floor = []
    for _ in range(m):
        x, y = map(int, input().split())
        floor.append((x, -y))

    top = compute(w, h, ceiling)
    bot = [-x for x in compute(w, h, floor)]

    lo, hi = 0, 0
    for i in range(1, w + 1):
        lo = max(lo - 1, bot[i] + int(bot[i] % 2 != i % 2))
        hi = min(hi + 1, top[i] - int(top[i] % 2 != i % 2))
        if lo > hi:
            print("impossible")
            return

    print(lo, hi)


if __name__ == "__main__":
    main()
